program Labyrinth;

var
  i, j, T, C, R, count : Integer;
  tab : array[0..1001, 0..1001] of char;
  Best1, Best2 : array[1..1000, 1..1000] of Integer;
  MaxDist : Integer;
  PoczX, PoczY : Integer;
  ch : char;
  costam : Integer;
   
function max(a, b : Integer) : Integer;
begin
  if a>b then Max := a else Max := b;
end;

function DFS(x, y, dist : Integer) : Integer
var path : Integer
begin
  path := 0;
  tab[x][y] := '#';
  if dist > MaxDist then begin 
    MaxDist := dist; 
    Writeln('(',x:1,',',y:1,'), MaxDist <- ',MaxDist:1); 
  end;    
  if tab[x][y-1] = '.' then begin
    path := DFS(x, y-1, Max(dist+1, Path-Dist+1));
  end;  
  if tab[x][y+1] = '.' then begin
    DFS(x, y+1, Max(dist+1, MaxDist-Dist+1));
  end;  
  if tab[x-1][y] = '.' then begin
    DFS(x-1, y, Max(dist+1, MaxDist-Dist+1));
  end;  
  if tab[x+1][y] = '.' then begin
    DFS(x+1, y, Max(dist+1, MaxDist-Dist+1));
  end;  
end;


begin
  Read(T);
  for count := 1 to T do begin
    Readln;
    Read(C, R);
    PoczX := -1;
    PoczY := -1;
    for i := 1 to R do begin
      Readln;     
      for j := 1 to C do begin
        Read(ch);
        tab[i][j] := ch; 
	if tab[i][j] = '.' then begin PoczX := i; PoczY := j; end;
      end;	
    
    end;
    MaxDist := 0;
    if PoczX < 0 then begin
      Writeln('Maximum rope length is 0.');
      Continue;
    end;
    for i := 0 to R+1 do begin
     tab[i][0] := '#';
     tab[i][c+1] := '#';
    end;
    for i := 0 to C+1 do begin
     tab[0][i] := '#';
     tab[R+1][i] := '#'; 
    end;
    
    Writeln;
    for i := 0 to R+1 do begin
     for j := 0 to C+1 do Write(tab[i][j]);
     Writeln;
    end;

    costam := DFS(PoczX, PoczY, 0);

    
    Writeln('Maximum rope length is ',MaxDist:1,'.');
  end;
end.