program Stone;

var
  CenterX: Real;
  CenterY: Real;
  TotalWeight: Real;
  
procedure Go(X1, Y1, X2, Y2: Integer);
	     
var
  Weight: Real;
  
begin
  Weight := 2.0 * (X2 - X1) * Y1;
  CenterX := CenterX + (X1 + X2) * 3.0 * Weight;
  CenterY := CenterY + (Y1     ) * 3.0 * Weight;
  TotalWeight := TotalWeight + Weight;
  Weight := 1.0 * (X2 - X1) * (Y2 - Y1);
  CenterX := CenterX + (X1 + 2 * X2) * 2.0 * Weight;
  CenterY := CenterY + (2 * Y1 + Y2) * 2.0 * Weight;
  TotalWeight := TotalWeight + Weight;
end;

var
  I: Integer;
  J: Integer;
  LastX: Integer;
  LastY: Integer;
  N: Integer;
  StartX: Integer;
  StartY: Integer;
  T: Integer;
  X: Integer;
  Y: Integer;
  
begin
  Readln(T);
  for I := 1 to T do
  begin
    Readln(N);
    Read(StartX);
    Readln(StartY);
    LastX := StartX;
    LastY := StartY;
    CenterX := 0;
    CenterY := 0;
    TotalWeight := 0;
    for J := 2 to N do
    begin
      Read(X);
      Readln(Y);
      Go(LastX+20000, LastY+20000, X+20000, Y+20000);
      LastX := X;
      LastY := Y;
    end;
    Go(LastX+20000, LastY+20000, StartX+20000, StartY+20000);
    TotalWeight := TotalWeight * 6;
    CenterX := CenterX / TotalWeight;
    CenterY := CenterY / TotalWeight;
    
    CenterX := Round(100 * CenterX) / 100 - 20000;
    CenterY := Round(100 * CenterY) / 100 - 20000;

    WriteLn(CenterX:4:2, ' ', CenterY:4:2);
  end;  
end.