program Labyrinth;

const
  DX: array [0..3] of Integer = (1, 0, -1, 0);
  DY: array [0..3] of Integer = (0, 1, 0, -1);
  
var
  Visited: array [1..1000, 1..1000] of Boolean;
  Lab: array [1..1000, 1..1000] of Char;
  C: Integer;
  Max: Integer;
  R: Integer;

function Go(X: Integer;
            Y: Integer): Integer;
	    
var
  Best1: Integer;
  Best2: Integer;
  D: Integer;
  L: Integer;
  
begin
  Best1 := 0;
  Best2 := 0;
  Visited[X, Y] := True;
  for D := 0 to 3 do
    if (X + DX[D] >= 1) and (X + DX[D] <= C) and
       (Y + DY[D] >= 1) and (Y + DY[D] <= R) then
      if Lab[X + DX[D], Y + DY[D]] = '.' then
        if not Visited[X + DX[D], Y + DY[D]] then
        begin
          L := Go(X + DX[D], Y + DY[D]) + 1;
          if L >= Best1 then
   	  begin
	    Best2 := Best1;
	    Best1 := L;
	  end
	  else if L > Best2 then
	    Best2 := L;
	end;
  Go := Best1;
  if Best1 + Best2 > Max then
    Max := Best1 + Best2;
end;

var
  I: Integer;
  StartX: Integer;
  StartY: Integer;
  T: Integer;
  Y: Integer;
  X: Integer;
  
begin
  Readln(T);
  for I := 1 to T do
  begin
    Read(C);
    Readln(R);
    StartX := 0;
    StartY := 0;
    for Y := 1 to R do
    begin
      for X := 1 to C do
      begin
        Read(Lab[X, Y]);
	Visited[X, Y] := False;
	if Lab[X, Y] = '.' then
	begin
	  StartX := X;
	  StartY := Y;
	end;
      end;
      Readln;
    end;
    Max := 0;
    if (StartX <> 0) or (StartY <> 0) then
      Go(StartX, StartY);
    Writeln('Maximum rope length is ', Max:1, '.');
  end;
end.